#include <stdio.h>
#include <malloc.h>

struct matrica{
        int  **mat;
        int m,n;
        struct matrica *next;
};

struct matrica* unos(struct matrica*);

void najmat(struct matrica *lista_matrica) {
	
	int i, j, suma=0, temp_suma, m_temp, n_temp, **mat_temp;
	if (lista_matrica==NULL) {
		printf("Lista je prazna\n");
		exit();
	}
	for (i=0; i<lista_matrica->m; i++)
		for (j=0; j<lista_matrica->n; j++)
			suma+=lista_matrica->mat[i][j];
	m_temp=lista_matrica->m;
	n_temp=lista_matrica->n;		
	mat_temp = (int**) malloc(m_temp*sizeof(int));	
	for (i=0; i<m_temp; i++) mat_temp[i]= (int*) malloc(n_temp*sizeof(int));	
	for (i=0; i<m_temp; i++)
		for (j=0; j<n_temp; j++)
			mat_temp[i][j]=lista_matrica->mat[i][j];
	lista_matrica=lista_matrica->next;		
	while (lista_matrica != NULL) {
		temp_suma=0;
		for (i=0; i<lista_matrica->m; i++)
		for (j=0; j<lista_matrica->n; j++)
			temp_suma+=lista_matrica->mat[i][j];
		if (temp_suma > suma) {
			suma=temp_suma;
			m_temp=lista_matrica->m;
			n_temp=lista_matrica->n;
			for (i=0; i<m_temp; i++) free(mat_temp[i]);
			free(mat_temp);			
			mat_temp = (int**) malloc(m_temp*sizeof(int));	
			for (i=0; i<m_temp; i++) mat_temp[i]= (int*) malloc(n_temp*sizeof(int));	
			for (i=0; i<m_temp; i++)
				for (j=0; j<n_temp; j++)
					mat_temp[i][j]=lista_matrica->mat[i][j];
			}
		lista_matrica=lista_matrica->next;	
	}
	for (i=0; i< m_temp; i++)
		for (j=0; j < n_temp; j++)
			printf("%d %s", mat_temp[i][j], (j==n_temp-1) ? "\n" : "\t");
	for (i=0; i<m_temp; i++) free(mat_temp[i]);
			free(mat_temp);	
}	

/* Testni program   */

int main ()
{
	struct matrica *lista_matrica, *temp;
	int brm, i, j;
	printf("Koliko matrica zelite unijeti?\n");
	scanf("%d", &brm);
    lista_matrica = (struct matrica*) malloc(sizeof(struct matrica));
    printf("Broj redaka:\n");
    scanf("%d", &lista_matrica->m);
	printf("Broj stupaca:\n");
    scanf("%d", &lista_matrica->n);
	lista_matrica->mat = (int**) malloc(lista_matrica->m*sizeof(int));	
	for (i=0; i<lista_matrica->m; i++) lista_matrica->mat[i]= (int*) malloc(lista_matrica->n*sizeof(int));
	for (i=0; i<lista_matrica->m; i++)
		for (j=0; j<lista_matrica->n; j++) {
			printf("(%d,%d)=?\n", i+1, j+1);
			scanf("%d", &lista_matrica->mat[i][j]);
		}
	temp=lista_matrica;
	for (i=1; i<brm; i++) 
		temp=unos(temp);
	najmat(lista_matrica);
	return 0;	
}	
	
struct matrica* unos(struct matrica *lista_matrica){
	
        struct matrica *novi;
		int i,j;
        novi = (struct matrica*) malloc(sizeof(struct matrica));
        printf("Broj redaka:\n");
        scanf("%d", &novi->m);
		printf("Broj stupaca:\n");
        scanf("%d", &novi->n);
		novi->mat = (int**) malloc(novi->m*sizeof(int));	
		for (i=0; i<novi->m; i++) novi->mat[i]= (int*) malloc(novi->n*sizeof(int));
		for (i=0; i<novi->m; i++)
			for (j=0; j<novi->n; j++) {
				printf("(%d,%d)=?\n", i+1, j+1;
				scanf("%d", &novi->mat[i][j]);
			}
		lista_matrica->next=novi;
		return novi; 
}
	
